// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/api/gsc_mem.h $
// $Rev: 30377 $
// $Date: 2014-09-18 12:09:04 -0500 (Thu, 18 Sep 2014) $

#ifndef __GSC_MEM_H__
#define __GSC_MEM_H__

#include "gsc_access.h"
#include "gsc_sem.h"



// data types *****************************************************************

typedef struct
{
	gsc_device_t*	device;
	gsc_sem_t		sem;
	U32				size;		// The size of the memory allocation.
	OS_USR_ADDR_T	usr_adrs;	// The user space address.
	unsigned long	phy_adrs;	// The physical address used for DMA.
} gsc_mem_t;



// prototypes *****************************************************************

U32		gsc_mem_alloc(gsc_mem_t* mem, U32 size, gsc_mem_t* dest);
U32		gsc_mem_create(gsc_mem_t* mem, const char* name, gsc_device_t* device);
void	gsc_mem_destroy(gsc_mem_t* mem);
U32		gsc_mem_test(gsc_mem_t* mem, void* ptr, U32 size, gsc_mem_t* tmp);



#endif
