// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/api/gsc_os_sleep.c $
// $Rev: 30377 $
// $Date: 2014-09-18 12:09:04 -0500 (Thu, 18 Sep 2014) $

#include <pthread.h>
#include <unistd.h>
#include <sys/time.h>

#include "gsc_os_sleep.h"
#include "gsc_common.h"



/******************************************************************************
*
*	Function:	os_sleep_ms
*
*	Purpose:
*
*		Sleep for the given number of milliseconds. The OS may sleep longer
*		than requested, much longer, due to factors outside our control.
*
*	Arguments:
*
*		ms	The number of milleseconds to sleep. If zero or less is given we
*			use one.
*
*	Returned:
*
*		None.
*
******************************************************************************/

void os_sleep_ms(long ms)
{

	struct timeval	now;
	long			slept;
	struct timeval	start;
	long			want;

	gettimeofday(&start, NULL);

	if (ms < 1)
		ms	= 1;

	for (;;)
	{
		if (ms >= 1000)
		{
			want	= ms / 1000;
			sleep(want);
		}
		else if (ms >= 1)
		{
			want	= ms * 1000;
			usleep(want);
		}
		else
		{
			ms	= 1;
			usleep(1000);
		}

		gettimeofday(&now, NULL);
		slept	= (((long) now.tv_sec  - (long) start.tv_sec ) * 1000)
				+ (((long) now.tv_usec - (long) start.tv_usec) / 1000);

		if (slept >= ms)
			break;
	}
}


