// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/api/gsc_plda.h $
// $Rev: 30377 $
// $Date: 2014-09-18 12:09:04 -0500 (Thu, 18 Sep 2014) $

#ifndef __GSC_PLDA_H__
#define __GSC_PLDA_H__

#include "gsc_common.h"

#ifdef __cplusplus
extern "C" {
#endif



// #defines *******************************************************************

#define	GSC_PCI_PLDA_ENCODE(s,o)	GSC_REG_ENCODE(GSC_REG_PCI,(s),(o))
#define	GSC_PLDA_ENCODE(s,o)		GSC_REG_ENCODE(GSC_REG_PLDA,(s),(o))

// PLDA: PCI Configuration Registers
#define GSC_PCI_PLDA_VIDR			GSC_PCI_PLDA_ENCODE(2, 0x00)
#define GSC_PCI_PLDA_DIDR			GSC_PCI_PLDA_ENCODE(2, 0x02)
#define GSC_PCI_PLDA_CR				GSC_PCI_PLDA_ENCODE(2, 0x04)
#define GSC_PCI_PLDA_SR				GSC_PCI_PLDA_ENCODE(2, 0x06)
#define GSC_PCI_PLDA_REV			GSC_PCI_PLDA_ENCODE(1, 0x08)
#define GSC_PCI_PLDA_CCR			GSC_PCI_PLDA_ENCODE(3, 0x09)
#define GSC_PCI_PLDA_CLSR			GSC_PCI_PLDA_ENCODE(1, 0x0C)
#define GSC_PCI_PLDA_LTR			GSC_PCI_PLDA_ENCODE(1, 0x0D)
#define GSC_PCI_PLDA_HTR			GSC_PCI_PLDA_ENCODE(1, 0x0E)
#define GSC_PCI_PLDA_BISTR			GSC_PCI_PLDA_ENCODE(1, 0x0F)
#define GSC_PCI_PLDA_BAR0			GSC_PCI_PLDA_ENCODE(4, 0x10)
#define GSC_PCI_PLDA_BAR1			GSC_PCI_PLDA_ENCODE(4, 0x14)
#define GSC_PCI_PLDA_BAR2			GSC_PCI_PLDA_ENCODE(4, 0x18)
#define GSC_PCI_PLDA_BAR3			GSC_PCI_PLDA_ENCODE(4, 0x1C)
#define GSC_PCI_PLDA_BAR4			GSC_PCI_PLDA_ENCODE(4, 0x20)
#define GSC_PCI_PLDA_BAR5			GSC_PCI_PLDA_ENCODE(4, 0x24)
#define GSC_PCI_PLDA_CIS			GSC_PCI_PLDA_ENCODE(4, 0x28)
#define GSC_PCI_PLDA_SVID			GSC_PCI_PLDA_ENCODE(2, 0x2C)
#define GSC_PCI_PLDA_SID			GSC_PCI_PLDA_ENCODE(2, 0x2E)
#define GSC_PCI_PLDA_ERBAR			GSC_PCI_PLDA_ENCODE(4, 0x30)
#define GSC_PCI_PLDA_CAP_PTR		GSC_PCI_PLDA_ENCODE(1, 0x34)
#define GSC_PCI_PLDA_ILR			GSC_PCI_PLDA_ENCODE(1, 0x3C)
#define GSC_PCI_PLDA_IPR			GSC_PCI_PLDA_ENCODE(1, 0x3D)
#define GSC_PCI_PLDA_MGR			GSC_PCI_PLDA_ENCODE(1, 0x3E)
#define GSC_PCI_PLDA_MLR			GSC_PCI_PLDA_ENCODE(1, 0x3F)

// PLDA: General Registers
#define GSC_PLDA_MARBR				GSC_PLDA_ENCODE(4, 0x08)
#define GSC_PLDA_BIGEND				GSC_PLDA_ENCODE(4, 0x0C)
#define GSC_PLDA_INTCSR				GSC_PLDA_ENCODE(4, 0x68)

// PLDA: DMA Registers
#define GSC_PLDA_DMAMODE0			GSC_PLDA_ENCODE(4, 0x80)
#define GSC_PLDA_DMAPLADR0			GSC_PLDA_ENCODE(4, 0x84)
#define GSC_PLDA_DMALADR0			GSC_PLDA_ENCODE(4, 0x88)
#define GSC_PLDA_DMASIZ0			GSC_PLDA_ENCODE(4, 0x8C)
#define GSC_PLDA_DMADPR0			GSC_PLDA_ENCODE(4, 0x90)
#define GSC_PLDA_DMAMODE1			GSC_PLDA_ENCODE(4, 0x94)
#define GSC_PLDA_DMAPLADR1			GSC_PLDA_ENCODE(4, 0x98)
#define GSC_PLDA_DMALADR1			GSC_PLDA_ENCODE(4, 0x9C)
#define GSC_PLDA_DMASIZ1			GSC_PLDA_ENCODE(4, 0xA0)
#define GSC_PLDA_DMADPR1			GSC_PLDA_ENCODE(4, 0xA4)
#define GSC_PLDA_DMACSR0			GSC_PLDA_ENCODE(1, 0xA8)
#define GSC_PLDA_DMACSR1			GSC_PLDA_ENCODE(1, 0xA9)
#define GSC_PLDA_DMAARB				GSC_PLDA_ENCODE(4, 0xAC)
#define GSC_PLDA_DMATHR				GSC_PLDA_ENCODE(4, 0xB0)
#define GSC_PLDA_DMAPUADR0			GSC_PLDA_ENCODE(4, 0xB4)
#define GSC_PLDA_DMAPUADR1			GSC_PLDA_ENCODE(4, 0xB8)



#ifdef __cplusplus
}
#endif

#endif
