#include <stdio.h>

#include "hpdi32_dsl.h"

U32	hpdi32_dsl_io_tx_wait(void* handle, U32 timeout_ms, int verbose)
{
	U32	status;

	status	= hpdi32_io_wait(handle, HPDI32_WHICH_TX, timeout_ms);

	if (!verbose)
	{
	}
	else if (status == GSC_SUCCESS)
	{
		printf("Tx Wait: write operation completed.\n");
	}
	else if (status == GSC_WAIT_TIMEOUT)
	{
		printf(	"Tx Wait: timeout after %ld milliseconds\n",
				(long) timeout_ms);
	}
	else
	{
		printf("hpdi32_io_wait() failure: %ld\n", (long) status);
	}

	return(status);
}
