// This software is covered by the GNU GENERAL PUBLIC LICENSE (GPL).
// HPDI32 - Driver - Linux
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/driver/dev_os_version.c $
// $Rev: 28942 $
// $Date: 2014-08-01 15:59:26 -0500 (Fri, 01 Aug 2014) $

#include "dev_version.h"
#include "main.h"



int dev_os_id_device(struct pci_dev* pci)
{
	u16	did;
	int	ours;
	u16	sid;
	u16	svd;
	u16	vid;

	pci_read_config_word(pci, PCI_VENDOR_ID, &vid);
	pci_read_config_word(pci, PCI_DEVICE_ID, &did);
	pci_read_config_word(pci, PCI_SUBSYSTEM_VENDOR_ID, &svd);
	pci_read_config_word(pci, PCI_SUBSYSTEM_ID, &sid);

	if ((vid == 0x10B5) &&
		(did == 0x9080) &&
		(svd == 0x10B5) &&
		(sid == 0x2400))
	{
		// This is a 32-bit HPDI32.
		ours	= 1;
	}
	else if (	(vid == 0x10B5) &&
				(did == 0x9656) &&
				(svd == 0x10B5) &&
				(sid == 0x2705))
	{
		// This is a 64-bit HPDI32.
		ours	= 1;
	}
	else
	{
		ours	= 0;
	}

	return(ours);
}



