// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/gpio/lib/ctrl.c $
// $Rev: 30430 $
// $Date: 2014-10-07 14:49:48 -0500 (Tue, 07 Oct 2014) $

#include <string.h>

#include "main.h"



//*****************************************************************************
U32 ctrl_cap_get(void* dev, U8* cap, U8* cfg_mask)
{
	U8	cap_tmp			= 0;
	U8	cfg_mask_tmp	= 0;
	U32	status;

	status	= ctrl_def_cap_get(dev, &cap_tmp, &cfg_mask_tmp);

	if (cap)
		cap[0]		= cap_tmp;

	if (cfg_mask)
		cfg_mask[0]	= cfg_mask_tmp;

	return(status);
}



//*****************************************************************************
U32 ctrl_enable_get(void* dev, U8* cfg_en)
{
	U8	cap			= 0;
	U8	cfg_en_tmp	= 0;
	U8	cfg_mask	= 0;
	U32	status;
	U32	sts;

	for (;;)	// A convenience loop.
	{
		status	= gpio_dev_cap_get(dev, &cap, &cfg_mask, NULL);

		if (status != GSC_SUCCESS)
			break;

		if (((cap & HPDI32_GPIO_CAP_CTRL_TX) == 0) &&
			((cap & HPDI32_GPIO_CAP_CTRL_RX) == 0))
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cfg_mask == 0)		// There is nothing to access.
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cap & HPDI32_GPIO_CAP_CTRL_0_6)
		{
			sts		= ctrl_def_enable_get(dev, &cfg_en_tmp);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else if (cap & HPDI32_GPIO_CAP_CTRL_0_5)
		{
			sts		= ctrl_def_enable_get(dev, &cfg_en_tmp);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else
		{
			sts		= GSC_UNSUPPORTED_FUNCTION;
			status	= (status == GSC_SUCCESS) ? sts : status;
		}

		if (cfg_en)
			cfg_en[0]	= cfg_en_tmp;

		break;
	}

	return(status);
}



//*****************************************************************************
U32 ctrl_enable_set(void* dev, U8 cfg_en, U8 cfg_dir, U8 io_bin)
{
	U8	cap			= 0;
	U8	cfg_mask	= 0;
	U32	status		= GSC_SUCCESS;
	U32	sts;

	for (;;)	// A convenience loop.
	{
		status	= gpio_dev_cap_get(dev, &cap, &cfg_mask, NULL);

		if (status != GSC_SUCCESS)
			break;

		if (((cap & HPDI32_GPIO_CAP_CTRL_TX) == 0) &&
			((cap & HPDI32_GPIO_CAP_CTRL_RX) == 0))
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cfg_mask == 0)		// There is nothing to access.
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cap & HPDI32_GPIO_CAP_CTRL_0_6)
		{
			sts		= ctrl_def_enable_set(dev, cfg_en, cfg_dir, io_bin);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else if (cap & HPDI32_GPIO_CAP_CTRL_0_5)
		{
			sts		= ctrl_def_enable_set(dev, cfg_en, cfg_dir, io_bin);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else
		{
			sts		= GSC_UNSUPPORTED_FUNCTION;
			status	= (status == GSC_SUCCESS) ? sts : status;
		}

		break;
	}

	return(status);
}



//*****************************************************************************
U32 ctrl_dir_out_get(void* dev, U8* cfg_dir)
{
	U8	cap			= 0;
	U8	cfg_dir_tmp	= 0;
	U8	cfg_mask	= 0;
	U32	status;
	U32	sts;

	for (;;)	// A convenience loop.
	{
		status	= gpio_dev_cap_get(dev, &cap, &cfg_mask, NULL);

		if (status != GSC_SUCCESS)
			break;

		if (((cap & HPDI32_GPIO_CAP_CTRL_TX) == 0) &&
			((cap & HPDI32_GPIO_CAP_CTRL_RX) == 0))
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cfg_mask == 0) // There is nothing to access.
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cap & HPDI32_GPIO_CAP_CTRL_0_6)
		{
			sts		= ctrl_def_dir_out_get(dev, &cfg_dir_tmp);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else if (cap & HPDI32_GPIO_CAP_CTRL_0_5)
		{
			sts		= ctrl_def_dir_out_get(dev, &cfg_dir_tmp);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else
		{
			sts		= GSC_UNSUPPORTED_FUNCTION;
			status	= (status == GSC_SUCCESS) ? sts : status;
		}

		if (cfg_dir)
			cfg_dir[0]	= cfg_dir_tmp;

		break;
	}

	return(status);
}



//*****************************************************************************
U32 ctrl_dir_out_set(void* dev, U8 cfg_dir, U8 io_bin)
{
	U8	cap			= 0;
	U8	cfg_mask	= 0;
	U32	status;
	U32	sts;

	for (;;)	// A convenience loop.
	{
		status	= gpio_dev_cap_get(dev, &cap, &cfg_mask, NULL);

		if (status != GSC_SUCCESS)
			break;

		if (((cap & HPDI32_GPIO_CAP_CTRL_TX) == 0) &&
			((cap & HPDI32_GPIO_CAP_CTRL_RX) == 0))
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cfg_mask == 0) // There is nothing to access.
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cap & HPDI32_GPIO_CAP_CTRL_0_6)
		{
			sts		= ctrl_def_dir_out_set(dev, cfg_dir, io_bin);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else if (cap & HPDI32_GPIO_CAP_CTRL_0_5)
		{
			sts		= ctrl_def_dir_out_set(dev, cfg_dir, io_bin);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else
		{
			sts		= GSC_UNSUPPORTED_FUNCTION;
			status	= (status == GSC_SUCCESS) ? sts : status;
		}

		break;
	}

	return(status);
}



//*****************************************************************************
U32 hpdi32_gpio_ctrl_rx(void* dev, U8* io_bin)
{
	U8	cap			= 0;
	U8	cfg_mask	= 0;
	U8	io_bin_tmp	= 0;
	U32	status;
	U32	sts;

	for (;;)	// A convenience loop.
	{
		status	= gpio_dev_cap_get(dev, &cap, &cfg_mask, NULL);

		if (status != GSC_SUCCESS)
			break;

		if ((cap & HPDI32_GPIO_CAP_CTRL_RX) == 0)
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cfg_mask == 0) // There is nothing to access.
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cap & HPDI32_GPIO_CAP_CTRL_0_6)
		{
			sts		= ctrl_def_rx(dev, &io_bin_tmp);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else if (cap & HPDI32_GPIO_CAP_CTRL_0_5)
		{
			sts		= ctrl_def_rx(dev, &io_bin_tmp);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else
		{
			sts		= GSC_UNSUPPORTED_FUNCTION;
			status	= (status == GSC_SUCCESS) ? sts : status;
		}

		if (io_bin)
			io_bin[0]	= io_bin_tmp;

		break;
	}

	return(status);
}



//*****************************************************************************
U32 hpdi32_gpio_ctrl_tx(void* dev, U8 io_bin)
{
	U8	cap			= 0;
	U8	cfg_mask	= 0;
	U32	status		= GSC_SUCCESS;
	U32	sts;

	for (;;)	// A convenience loop.
	{
		status	= gpio_dev_cap_get(dev, &cap, &cfg_mask, NULL);

		if (status != GSC_SUCCESS)
			break;

		if ((cap & HPDI32_GPIO_CAP_CTRL_TX) == 0)
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cfg_mask == 0) // There is nothing to access.
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cap & HPDI32_GPIO_CAP_CTRL_0_6)
		{
			sts		= ctrl_def_tx(dev, io_bin);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else if (cap & HPDI32_GPIO_CAP_CTRL_0_5)
		{
			sts		= ctrl_def_tx(dev, io_bin);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else
		{
			sts		= GSC_UNSUPPORTED_FUNCTION;
			status	= (status == GSC_SUCCESS) ? sts : status;
		}

		break;
	}

	return(status);
}


