// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/gpio/lib/hpdi32_gpio.h $
// $Rev: 30430 $
// $Date: 2014-10-07 14:49:48 -0500 (Tue, 07 Oct 2014) $

#ifndef __HPDI32_GPIO_H__
#define __HPDI32_GPIO_H__

#include "hpdi32_api.h"



// #defines *******************************************************************

// These are for the capabilities.
#define	HPDI32_GPIO_CAP_CTRL_0_5	0x01
#define	HPDI32_GPIO_CAP_CTRL_0_6	0x02
#define	HPDI32_GPIO_CAP_CTRL_RX		0x04
#define	HPDI32_GPIO_CAP_CTRL_TX		0x08

#define	HPDI32_GPIO_CAP_DATA_EXP	0x10
#define	HPDI32_GPIO_CAP_DATA_SIM	0x20
#define	HPDI32_GPIO_CAP_DATA_RX		0x40
#define	HPDI32_GPIO_CAP_DATA_TX		0x80

// hpdi32_gpio_config_get/set(): enable and direction bits
#define	HPDI32_GPIO_CFG_0			0x01
#define	HPDI32_GPIO_CFG_1			0x02
#define	HPDI32_GPIO_CFG_2			0x04
#define	HPDI32_GPIO_CFG_3			0x08
#define	HPDI32_GPIO_CFG_4			0x10
#define	HPDI32_GPIO_CFG_5			0x20
#define	HPDI32_GPIO_CFG_6			0x40
#define	HPDI32_GPIO_CFG_D32			0x80



// prototypes *****************************************************************

U32		hpdi32_gpio_config_get(void* dev, U8* cfg_en, U8* cfg_dir);
U32		hpdi32_gpio_config_set(void* dev, U8 cfg_en, U8 cfg_dir, U8 ctrl_io_bin, U32 data_io_bin);
U32		hpdi32_gpio_ctrl_rx(void* dev, U8* io_bin);
U32		hpdi32_gpio_ctrl_tx(void* dev, U8 io_bin);

U32		hpdi32_gpio_data_rx(void* dev, U32* io_bin);
U32		hpdi32_gpio_data_tx(void* dev, U32 io_bin);
U32		hpdi32_gpio_dev_cap_get(void* dev, U8* cap);
void	hpdi32_gpio_dev_release(void* dev);

void	hpdi32_gpio_lib_init(void);
void	hpdi32_gpio_lib_release(void);




#endif
