// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/gpio/utils/util_gpio_config_set.c $
// $Rev: 30431 $
// $Date: 2014-10-07 14:50:22 -0500 (Tue, 07 Oct 2014) $

#include <stdio.h>

#include "hpdi32_utils.h"
#include "hpdi32_gpio_utils.h"



//*****************************************************************************
int dev_gpio_config_set(void* dev, int index, int verbose, U8 cfg_en, U8 cfg_dir, U8 ctrl_io_bin, U32 data_io_bin)
{
	int	errs	= 0;
	U32	status	= GSC_SUCCESS;

	if (verbose)
		label_text_index("GPIO Set Configuration", index);

	status	= hpdi32_gpio_config_set(dev, cfg_en, cfg_dir, ctrl_io_bin, data_io_bin);
	errs	+= (status == GSC_SUCCESS) ? 0 : 1;

	if (verbose)
	{
		printf(	"%s  (Enable 0x%02lX, Outputs 0x%02lX, Control 0x%02lX, Data 0x%08lX)\n",
				errs ? "FAIL <---" : "PASS",
				(long) cfg_en,
				(long) cfg_dir,
				(long) ctrl_io_bin,
				(long) data_io_bin);
	}

	return(errs);
}


