// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/gpio/utils/util_gpio_dev_cap_get.c $
// $Rev: 30431 $
// $Date: 2014-10-07 14:50:22 -0500 (Tue, 07 Oct 2014) $

#include <stdio.h>

#include "hpdi32_utils.h"
#include "hpdi32_gpio_utils.h"



//*****************************************************************************
static int _ctrl_capabilities(int verbose, int cap)
{
	int			errs	= 0;
	const char*	ptr;

	if (verbose)
		label_text("Control Lines");

	if (cap & HPDI32_GPIO_CAP_CTRL_0_6)
	{
		ptr	= "7 Lines  (GPIO 0-6)";
	}
	else if (cap & HPDI32_GPIO_CAP_CTRL_0_5)
	{
		ptr	= "6 Lines  (GPIO 0-5)";
	}
	else
	{
		ptr	= "None";
	}

	if (verbose)
		printf("%s\n", ptr);

	return(errs);
}



//*****************************************************************************
static int _data_capabilities(int verbose, U8 cap)
{
	int			errs	= 0;
	const char*	ptr;

	if (verbose)
		label_text("Data Lines");

	if (cap & HPDI32_GPIO_CAP_DATA_EXP)
	{
		ptr	= "32 Lines  (Explicit Support)";
	}
	else if (cap & HPDI32_GPIO_CAP_DATA_SIM)
	{
		ptr	= "32 Lines  (Simulated, Rx requires external clock)";
	}
	else
	{
			ptr	= "None";
	}

	if (verbose)
		printf("%s\n", ptr);

	return(errs);
}



//*****************************************************************************
int dev_gpio_dev_cap_get(void* dev, int index, int verbose, U8* cap)
{
	U8	cap_tmp;
	int	errs			= 0;
	U32	status			= GSC_SUCCESS;

	if (verbose)
		label_text_index("GPIO Capabilities", index);

	status	= hpdi32_gpio_dev_cap_get(dev, &cap_tmp);
	errs	+= (status == GSC_SUCCESS) ? 0 : 1;

	if (verbose)
	{
		if (errs)
			printf("FAIL <---");

		printf("\n");
	}

	label_level_inc();
	errs	+= _ctrl_capabilities(verbose, cap_tmp);
	errs	+= _data_capabilities(verbose, cap_tmp);
	label_level_dec();

	if (cap)
		cap[0]		= cap_tmp;

	return(errs);
}


