// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/utils/util_cable_command_mode_0.c $
// $Rev: 30390 $
// $Date: 2014-09-18 12:16:55 -0500 (Thu, 18 Sep 2014) $

#include <stdio.h>

#include "hpdi32_utils.h"



//*****************************************************************************
int dev_cable_command_mode_0(void* dev, int index, int verbose, unsigned long set, unsigned long* get)
{
	char		buf[128];
	int			errs;
	const char*	ptr;
	U32			status;

	if (verbose)
		label_text_index("Cable Command 0 Mode", index);

	status	= hpdi32_config(dev, HPDI32_CABLE_COMMAND_MODE, HPDI32_WHICH_COMMAND_0_, set, &set);
	errs	= (status == GSC_SUCCESS) ? 0 : 1;

	switch (set)
	{
		default:

			errs++;
			ptr	= buf;
			sprintf(buf, "Unrecognized option: 0x%lX", (long) set);
			break;

		case HPDI32_CABLE_COMMAND_MODE_FLOW_CONTROL:

			ptr	= "Frame Valid";
			break;

		case HPDI32_CABLE_COMMAND_MODE_GPIO_IN:

			ptr	= "GPIO 6 Input";
			break;

		case HPDI32_CABLE_COMMAND_MODE_GPIO_OUT_LOW:

			ptr	= "GPIO 6 Output Low";
			break;

		case HPDI32_CABLE_COMMAND_MODE_GPIO_OUT_HI:

			ptr	= "GPIO 6 Output High";
			break;
	}

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", ptr);

	if (get)
		get[0]	= set;

	return(errs);
}


