// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/utils/util_close.c $
// $Rev: 30390 $
// $Date: 2014-09-18 12:16:55 -0500 (Thu, 18 Sep 2014) $

#include <stdio.h>

#include "hpdi32_utils.h"



/******************************************************************************
*
*	Function:	dev_close
*
*	Purpose:
*
*		Implement a wrapper around the similarly named HPDI32 function.
*
*	Arguments:
*
*		index	The index of the device being closed.
*
*		dev		The device handle to close.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dev_close(int index, void* dev)
{
	char	buf[64];
	int		errs	= 0;
	U32		status;

	sprintf(buf, "Closing HPDI32 #%d", index);
	label_text(buf);
	status	= hpdi32_close(dev);
	errs	= label_fail_func(1, "hpdi32_close", status);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


