// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/utils/util_rx_io_dma_control_mode.c $
// $Rev: 30390 $
// $Date: 2014-09-18 12:16:55 -0500 (Thu, 18 Sep 2014) $

#include <stdio.h>

#include "hpdi32_utils.h"



//*****************************************************************************
int dev_rx_io_dma_control_mode(void* dev, int index, int verbose, unsigned long set, unsigned long* get)
{
	char		buf[128];
	int			errs;
	const char*	ptr;
	U32			status;

	if (verbose)
		label_text_index("Rx I/O DMA Control Mode", index);

	status	= hpdi32_config(dev, HPDI32_IO_DMA_CONTROL_MODE, HPDI32_WHICH_RX, set, &set);
	errs	= (status == GSC_SUCCESS) ? 0 : 1;

	switch (set)
	{
		default:

			errs++;
			ptr	= buf;
			sprintf(buf, "Unrecognized option: 0x%lX", (long) set);
			break;

		case HPDI32_IO_DMA_CONTROL_MODE_MANUAL:

			ptr	= "Manual";
			break;

		case HPDI32_IO_DMA_CONTROL_MODE_AUTOMATIC:

			ptr	= "Automatic";
			break;
	}

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", ptr);

	if (get)
		get[0]	= set;

	return(errs);
}


