// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/utils/util_tx_io_data_size.c $
// $Rev: 30390 $
// $Date: 2014-09-18 12:16:55 -0500 (Thu, 18 Sep 2014) $

#include <stdio.h>

#include "hpdi32_utils.h"



//*****************************************************************************
int dev_tx_io_data_size(void* dev, int index, int verbose, unsigned long set, unsigned long* get)
{
	char		buf[128];
	int			errs;
	const char*	ptr;
	U32			status;

	if (verbose)
		label_text_index("Tx I/O Data Size", index);

	status	= hpdi32_config(dev, HPDI32_IO_DATA_SIZE, HPDI32_WHICH_TX, set, &set);
	errs	= (status == GSC_SUCCESS) ? 0 : 1;

	switch (set)
	{
		default:

			errs++;
			ptr	= buf;
			sprintf(buf, "Unrecognized option: 0x%lX", (long) set);
			break;

		case HPDI32_IO_DATA_SIZE_8_BITS:

			ptr	= "8-bits";
			break;

		case HPDI32_IO_DATA_SIZE_16_BITS:

			ptr	= "16-bits";
			break;

		case HPDI32_IO_DATA_SIZE_32_BITS:

			ptr	= "32-bits";
			break;
	}

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", ptr);

	if (get)
		get[0]	= set;

	return(errs);
}


